// SetupTasksExt.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "SetupTasksExt.h"
#include "regsvrutil.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE			g_hInst;				// The current instance

static SHACTIVATEINFO s_sai;

// Forward declarations of functions included in this code module:
LRESULT CALLBACK	DialogProc (HWND, UINT, WPARAM, LPARAM);


int
WINAPI
WinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPTSTR    lpCmdLine,
	int       nCmdShow
)
{
	g_hInst = hInstance;
	DialogBox(hInstance, (LPCTSTR)IDD_SETUP, NULL, (DLGPROC)DialogProc);
	return 0;
}

static
BOOL
IsAlreadyRegistered()
{
	BOOL	bRet;
	TCHAR	szRegKeyName[MAX_PATH + 1];
	HKEY	hKey = NULL;
	LONG	lResult;

	bRet = FALSE;

	memset(szRegKeyName, 0, sizeof(szRegKeyName));
	LoadString(g_hInst, IDS_CHECK_REGKEY, szRegKeyName, sizeof(szRegKeyName)/sizeof(szRegKeyName[0]) - 1);
	lResult = RegOpenKeyEx(HKEY_CLASSES_ROOT, szRegKeyName, 0, 0, &hKey);
	if (lResult == ERROR_SUCCESS) {

		bRet = TRUE;

		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}

static
int
myMessageBox(
	HWND	hWnd,
	UINT	uiTextID,
	UINT	uiCaptionID,
	UINT	uType
)
{
	int		iRet;
	TCHAR	szText[MAX_PATH + 1];
	TCHAR	szCaption[MAX_PATH + 1];

	memset(szText, 0, sizeof(szText));
	memset(szCaption, 0, sizeof(szCaption));

	LoadString(g_hInst, uiTextID, szText, sizeof(szText)/sizeof(szText[0]));
	LoadString(g_hInst, uiCaptionID, szCaption, sizeof(szCaption)/sizeof(szCaption[0]));

	iRet = MessageBox(hWnd, szText, szCaption, uType);

	return iRet;
}


// Mesage handler for the About box.
LRESULT CALLBACK DialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	switch (message)
	{
		case WM_INITDIALOG:
			{
				TCHAR	szText[MAX_PATH + 1];

				// Create a Done button and size it.  
				shidi.dwMask = SHIDIM_FLAGS;
				shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
				shidi.hDlg = hDlg;
				SHInitDialog(&shidi);

				// ݒ̓ǂݍ
				if (IsAlreadyRegistered()) {
					HWND	hBtn;

					memset(szText, 0, sizeof(szText));
					LoadString(g_hInst, IDS_STATIC_REGISTERED, szText, sizeof(szText)/sizeof(szText[0]) - 1 );
					SetDlgItemText(hDlg, IDC_STATIC_STATE, szText);

					hBtn = GetDlgItem(hDlg, IDC_REGISTER);
					EnableWindow(hBtn, FALSE);
				}
				else {
					HWND	hBtn;

					memset(szText, 0, sizeof(szText));
					LoadString(g_hInst, IDS_STATIC_UNREGISTERED, szText, sizeof(szText)/sizeof(szText[0]) - 1 );
					SetDlgItemText(hDlg, IDC_STATIC_STATE, szText);

					hBtn = GetDlgItem(hDlg, IDC_UNREGISTER);
					EnableWindow(hBtn, FALSE);
				}
			}
			return TRUE;
			break;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
			case IDOK:
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
				break;

			case IDCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
				break;

			case IDC_REGISTER:
				{
					int		iRet;
					BOOL	bRet;
					TCHAR	szDllName[MAX_PATH + 1];

					iRet = myMessageBox(hDlg, IDS_CONFIRM_REGISTER, IDS_MESSAGEBOX_CAPTION, MB_YESNO|MB_ICONQUESTION);
					if (iRet == IDYES) {
						memset(szDllName, 0, sizeof(szDllName));
						LoadString(g_hInst, IDS_USE_DLLNAME, szDllName, sizeof(szDllName)/sizeof(szDllName[0]));
						
						bRet = regsvrDllRegisterServer(szDllName);
						if (bRet) {

							TCHAR	szText[MAX_PATH + 1];

							memset(szText, 0, sizeof(szText));
							LoadString(g_hInst, IDS_STATIC_REGISTERED, szText, sizeof(szText)/sizeof(szText[0]) - 1 );
							SetDlgItemText(hDlg, IDC_STATIC_STATE, szText);

							EnableWindow(GetDlgItem(hDlg, IDC_REGISTER), FALSE);
							EnableWindow(GetDlgItem(hDlg, IDC_UNREGISTER), TRUE);

							myMessageBox(hDlg, IDS_REGISTER_SUCCESS, IDS_MESSAGEBOX_CAPTION, MB_OK|MB_ICONINFORMATION);
						}
						else {
							myMessageBox(hDlg, IDS_REGISTER_FAIL, IDS_MESSAGEBOX_CAPTION, MB_OK);
						}
					}
				}
				return TRUE;
				break;

			case IDC_UNREGISTER:
				{
					int		iRet;
					BOOL	bRet;
					TCHAR	szDllName[MAX_PATH + 1];

					iRet = myMessageBox(hDlg, IDS_CONFIRM_UNREGISTER, IDS_MESSAGEBOX_CAPTION, MB_YESNO|MB_ICONQUESTION);
					if (iRet == IDYES) {

						memset(szDllName, 0, sizeof(szDllName));
						LoadString(g_hInst, IDS_USE_DLLNAME, szDllName, sizeof(szDllName)/sizeof(szDllName[0]));
						
						bRet = regsvrDllUnregisterServer(szDllName);
						if (bRet) {
							TCHAR	szText[MAX_PATH + 1];

							memset(szText, 0, sizeof(szText));
							LoadString(g_hInst, IDS_STATIC_UNREGISTERED, szText, sizeof(szText)/sizeof(szText[0]) - 1 );
							SetDlgItemText(hDlg, IDC_STATIC_STATE, szText);

							EnableWindow(GetDlgItem(hDlg, IDC_REGISTER), TRUE);
							EnableWindow(GetDlgItem(hDlg, IDC_UNREGISTER), FALSE);

							myMessageBox(hDlg, IDS_UNREGISTER_SUCCESS, IDS_MESSAGEBOX_CAPTION, MB_OK|MB_ICONINFORMATION);
						}
						else {
							myMessageBox(hDlg, IDS_UNREGISTER_FAIL, IDS_MESSAGEBOX_CAPTION, MB_OK);
						}
					}

				}
				return TRUE;
				break;
			}
			break;
	}
    return FALSE;
}
