#include "stdafx.h"
#include "regsvrutil.h"

/* Defines */
#define	DLLREGISTERSERVER_FUNC_NAME		TEXT("DllRegisterServer")
#define DLLUNREGISTERSERVER_FUNC_NAME	TEXT("DllUnregisterServer")

/* Typedefs */
typedef HRESULT	(WINAPI * PFNDLLREGISTERSERVER)(void);
typedef HRESULT	(WINAPI * PFNDLLUNREGISTERSERVER)(void);

BOOL
regsvrDllRegisterServer(
	LPTSTR	pDLLName
)
{
	BOOL					bRet;
	HMODULE					hModule = NULL;
	PFNDLLREGISTERSERVER	pfnDllRegisterServer = NULL;
	HRESULT					hr;

	bRet = FALSE;	// default return value

	if (pDLLName != NULL) {
		hModule = LoadLibrary(pDLLName);
		if (hModule != NULL) {
			pfnDllRegisterServer = (PFNDLLREGISTERSERVER) GetProcAddress(hModule, DLLREGISTERSERVER_FUNC_NAME);
			if (pfnDllRegisterServer != NULL) {
				hr = (*pfnDllRegisterServer)();

				if (SUCCEEDED(hr)) {
					bRet = TRUE;
				}
			}

			FreeLibrary(hModule);
			hModule = NULL;
		}
	}

	return bRet;
}


BOOL
regsvrDllUnregisterServer(
	LPTSTR	pDLLName
)
{
	BOOL					bRet;
	HMODULE					hModule = NULL;
	PFNDLLUNREGISTERSERVER	pfnDllUnregisterServer = NULL;
	HRESULT					hr;

	bRet = FALSE;	// default return value

	if (pDLLName != NULL) {
		hModule = LoadLibrary(pDLLName);
		if (hModule != NULL) {
			pfnDllUnregisterServer = (PFNDLLUNREGISTERSERVER) GetProcAddress(hModule, DLLUNREGISTERSERVER_FUNC_NAME);
			if (pfnDllUnregisterServer != NULL) {
				hr = (*pfnDllUnregisterServer)();

				if (SUCCEEDED(hr)) {
					bRet = TRUE;
				}
			}

			FreeLibrary(hModule);
			hModule = NULL;
		}
	}

	return bRet;
}
