#include "common.h"

/* Globals Variables */

UINT      g_cRefDLL   = 0;        // reference count for this DLL
HINSTANCE g_hinstDLL  = NULL;     // instance handle


BOOL
WINAPI
DllMain(
	HANDLE	hInstDLL, 
	DWORD	dwReason, 
	LPVOID	lpvReserved
	)
{
	UNREFERENCED_PARAMETER(lpvReserved);

    if (DLL_PROCESS_ATTACH == dwReason) {
		DisableThreadLibraryCalls((HMODULE)hInstDLL);
		g_hinstDLL = (HINSTANCE)hInstDLL;
	}

	return TRUE;
}


STDAPI
DllCanUnloadNow()
{
	if (g_cRefDLL == 0) {
		return S_OK;
	}
	else {
		return S_FALSE;
	}
}


STDAPI
DllGetClassObject(
	REFCLSID	rclsid,
	REFIID		riid,
	LPVOID*		ppvOut
)
{
    if (ppvOut == NULL)	{
        return E_INVALIDARG;
	}

    *ppvOut = NULL;

    if (IsEqualIID(rclsid, CLSID_CTasksExt)) {
        CTasksExtClassFactory *pcf = new CTasksExtClassFactory;

        return pcf->QueryInterface(riid, ppvOut);
    }

	return CLASS_E_CLASSNOTAVAILABLE;
}


#define TASKSEXT_CLSID_REGKEY	_T("\\CLSID\\{677DAF0D-2C73-4433-BBDE-2E1A292F839A}")
#define TASKSEXT_EXT_DESC		_T("TasksExt Plugin")

//#define TASKSEXT_APP_REGKEY	_T("Software\\Microsoft\\Shell\\Extensions\\ContextMenus\\Tasks\\Edit_Edit\\{677DAF0D-2C73-4433-BBDE-2E1A292F839A}")		// ҏW
#define TASKSEXT_APP_REGKEY	_T("Software\\Microsoft\\Shell\\Extensions\\ContextMenus\\Tasks\\Main_Menu\\{677DAF0D-2C73-4433-BBDE-2E1A292F839A}")			// ꗗ
//#define TASKSEXT_APP_REGKEY	_T("Software\\Microsoft\\Shell\\Extensions\\ContextMenus\\Tasks\\Main_Tools\\{677DAF0D-2C73-4433-BBDE-2E1A292F839A}")		// ꗗ(?)
//#define TASKSEXT_APP_REGKEY	_T("Software\\Microsoft\\Shell\\Extensions\\ContextMenus\\Tasks\\Summary_Tools\\{677DAF0D-2C73-4433-BBDE-2E1A292F839A}")	// \
//#define TASKSEXT_APP_REGKEY	_T("Software\\Microsoft\\Shell\\Extensions\\ContextMenus\\Tasks\\Main_ContextMenu\\{677DAF0D-2C73-4433-BBDE-2E1A292F839A}")	// ReNXgj[


static
BOOL
CreateCLSIDRegistry()
{
	BOOL	bRet;
    LRESULT	lResult;
    HKEY	hKey = NULL;
    HKEY	hSubKey = NULL;
    DWORD	dwDisposition;
    TCHAR	wszValue[MAX_PATH + 1];
	TCHAR	wszAttrib[32];

	bRet = FALSE;	// default return value

    lResult = RegCreateKeyEx(	HKEY_CLASSES_ROOT,
								TASKSEXT_CLSID_REGKEY,
								0,
								NULL,
								0,
								0,
								NULL,
								&hKey,
								&dwDisposition	);

	if (lResult == ERROR_SUCCESS) {

		lstrcpy(wszValue, TASKSEXT_EXT_DESC);
		lResult = RegSetValueEx(hKey, NULL, 0, REG_SZ, (LPBYTE) wszValue, (lstrlen(wszValue) + 1) * sizeof(TCHAR));

		if (lResult == ERROR_SUCCESS) {
			lResult = RegCreateKeyEx(	hKey,
										TEXT("InprocServer32"),
										0,
										NULL,
										0,
										0,
										NULL,
										&hSubKey,
										&dwDisposition	);

			if (lResult == ERROR_SUCCESS) {

				GetModuleFileName(g_hinstDLL, wszValue, sizeof(wszValue)/sizeof(wszValue[0]));
				lResult = RegSetValueEx(hSubKey, NULL, 0, REG_SZ, (LPBYTE) wszValue, (lstrlen(wszValue) + 1) * sizeof(TCHAR));

				if (lResult == ERROR_SUCCESS) {

					lstrcpy(wszValue, _T("Free"));
					lstrcpy(wszAttrib, _T("ThreadingModel"));
					lResult = RegSetValueEx(hSubKey, wszAttrib, 0, REG_SZ, (LPBYTE) wszValue, (lstrlen(wszValue) + 1) * sizeof(TCHAR));

					if (lResult == ERROR_SUCCESS) {
						bRet = TRUE;
					}
				}
			}

			RegCloseKey(hSubKey);
			hSubKey = NULL;
		}

		RegCloseKey(hKey);
		hKey = NULL;
    }

	return bRet;
}

static
BOOL
CreateAppExtRegistry()
{
	BOOL	bRet;
    LRESULT	lResult;
    HKEY	hKey = NULL;
    HKEY	hSubKey = NULL;
    DWORD	dwDisposition;
    TCHAR	wszValue[32];

	bRet = FALSE;

    lResult = RegCreateKeyEx(	HKEY_LOCAL_MACHINE,
								TASKSEXT_APP_REGKEY,
	                            0,
								NULL,
								0,
								0,
								NULL, 
	                            &hKey,
								&dwDisposition	);

	if (lResult == ERROR_SUCCESS) {
		lstrcpy(wszValue, TASKSEXT_EXT_DESC);
		lResult = RegSetValueEx(hKey, NULL, 0, REG_SZ, (LPBYTE) wszValue, (lstrlen(wszValue) + 1) * sizeof(TCHAR));
		if (lResult == ERROR_SUCCESS) {
			bRet = TRUE;
		}
	}

	return bRet;
}

static
BOOL
DeleteCLSIDRegistry()
{
	BOOL	bRet;
	LRESULT	lResult;

	bRet = FALSE;

	lResult = RegDeleteKey(HKEY_CLASSES_ROOT, TASKSEXT_CLSID_REGKEY);
	if (lResult == ERROR_SUCCESS) {
		bRet = TRUE;
	}

	return bRet;
}

static
BOOL
DeleteAppExtRegistry()
{
	BOOL	bRet;
    LRESULT	lResult;

	bRet = FALSE;

	lResult = RegDeleteKey(HKEY_LOCAL_MACHINE, TASKSEXT_APP_REGKEY);
	if (lResult == ERROR_SUCCESS) {
		bRet = TRUE;
	}

	return bRet;
}


STDAPI
DllRegisterServer()
{
	HRESULT hr = E_FAIL;

	hr = E_FAIL;	// default return value

	if (CreateCLSIDRegistry()) {
		if (CreateAppExtRegistry()) {
			hr = S_OK;
		}
	}

	return hr;
}

STDAPI
DllUnregisterServer()
{
    HRESULT hr;

	hr = S_OK;	// default return value

	if (!DeleteCLSIDRegistry()) {
		hr = E_FAIL;
	}

	if (!DeleteAppExtRegistry()) {
		hr = E_FAIL;
	}

	return hr;
}